Index: LMDZ6/branches/Portage_acc/libf/dyn3d_common/infotrac.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/dyn3d_common/infotrac.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/dyn3d_common/infotrac.F90	(revision 4446)
@@ -520,74 +373,16 @@
    END DO
 
-IF(lOldCode) THEN
-
-   CALL infotrac_setHeredity                !--- SET FIELDS %iqParent, %nqChilds, %iGeneration, %gen0Name, %iqDescen, %nqDescen
-   CALL infotrac_isoinit                    !--- SET FIELDS %type, %iso_iName, %iso_iZone, %iso_iPhase
-   CALL getKey_init(tracers, isotopes)
-   IF(isoSelect('H2O')) RETURN              !--- Select water isotopes ; finished if no water isotopes
-   iH2O = ixIso                             !--- Keep track of water family index
-
-   !--- Remove the isotopic tracers from the tracers list passed to phytrac
-   nbtr    = nbtr -nqo*   ntiso             !--- ISOTOPIC TAGGING TRACERS ARE NOT PASSED TO THE PHYSICS
-   nqtottr = nqtot-nqo*(1+ntiso)            !--- NO H2O-FAMILY    TRACER  IS      PASSED TO THE PHYSICS
-
-   ALLOCATE(conv_flg(nbtr), pbl_flg(nbtr))
-#ifndef INCA
-   conv_flg(1:nbtr) = 1                                              !--- Convection activated for all tracers
-    pbl_flg(1:nbtr) = 1                                              !--- Boundary layer activated for all tracers
-#else
-   !--- Passive CO2 tracer is at position 1 because: H2O has been removed ; nqCO2/=0 in "inco" case only
-   conv_flg(1:nbtr) = [(1, ic=1, nqCO2),conv_flg_inca]
-    pbl_flg(1:nbtr) = [(1, ic=1, nqCO2), pbl_flg_inca]
-#endif
-
-ELSE
-
-   CALL initIsotopes(tracers, isotopes)
-   nbIso = SIZE(isotopes)
-   nqtottr = nqtot - COUNT(tracers%gen0Name == 'H2O' .AND. tracers%component == 'lmdz')
-   IF(nbIso/=0) THEN                        !--- ISOTOPES FOUND
-
-      !=== READ PHYSICAL PARAMETERS FROM "isotopes_params.def" FILE SPECIFIC TO WATER ISOTOPES
-      !    DONE HERE, AND NOT ONLY IN "infotrac_phy", BECAUSE SOME PHYSICAL PARAMS ARE NEEDED FOR RESTARTS (tnat, alpha_ideal)
-      CALL getKey_init(tracers, isotopes)
-      IF(isoSelect('H2O')) RETURN           !--- Select water isotopes ; finished if no water isotopes
-      iH2O = ixIso                          !--- Keep track of water family index
-      IF(getKey('tnat' , tnat,        isoName(1:niso))) CALL abort_gcm(modname, 'can''t read "tnat"', 1)
-      IF(getKey('alpha', alpha_ideal, isoName(1:niso))) CALL abort_gcm(modname, 'can''t read "alpha_ideal"', 1)
-
-      !=== MAKE SURE THE MEMBERS OF AN ISOTOPES FAMILY ARE PRESENT IN THE SAME PHASES
-      DO ix = 1, nbIso
-         iso => isotopes(ix)
-         !--- Check whether each isotope and tagging isotopic tracer is present in the same number of phases
-         DO it = 1, iso%ntiso
-            np = SUM([(COUNT(tracers(:)%name == addPhase(iso%trac(it), iso%phase(ip:ip))), ip=1, iso%nphas)])
-            IF(np == iso%nphas) CYCLE
-            WRITE(msg1,'("Found ",i0," phases for ",a," instead of ",i0)')np, TRIM(iso%trac(it)), iso%nphas
-            CALL abort_gcm(modname, msg1, 1)
-         END DO
-         DO it = 1, iso%niso
-            nz = SUM([(COUNT(iso%trac == TRIM(iso%trac(it))//'_'//iso%zone(iz)), iz=1, iso%nzone)])
-            IF(nz == iso%nzone) CYCLE
-            WRITE(msg1,'("Found ",i0," tagging zones for ",a," instead of ",i0)')nz, TRIM(iso%trac(it)), iso%nzone
-            CALL abort_gcm(modname, msg1, 1)
-         END DO
-      END DO
-   END IF
-
-END IF
+   !=== READ PHYSICAL PARAMETERS FOR ISOTOPES ; DONE HERE BECAUSE dynetat0 AND iniacademic NEED "tnat" AND "alpha_ideal"
+   niso = 0; nzone = 0; nphas = nqo; ntiso = 0; isoCheck = .FALSE.
+   IF(readIsotopesFile()) CALL abort_gcm(modname, 'Problem when reading isotopes parameters', 1)
+
+   !--- Convection / boundary layer activation for all tracers
+   ALLOCATE(conv_flg(nbtr)); conv_flg(1:nbtr) = 1
+   ALLOCATE( pbl_flg(nbtr));  pbl_flg(1:nbtr) = 1
 
    !--- Note: nqtottr can differ from nbtr when nmom/=0
-!   IF(COUNT(tracers%iso_iName == 0) - COUNT(delPhase(tracers%name) == 'H2O' .AND. tracers%component == 'lmdz') /= nqtottr) &
-!      CALL abort_gcm('infotrac_init', 'pb dans le calcul de nqtottr', 1)
-
-   !--- Some aliases to be removed later
-   ntraciso       => ntiso
-   ntraceurs_zone => nzone
-   qperemin       =  min_qParent
-   masseqmin      =  min_qMass
-   ratiomin       =  min_ratio
-   iqiso          => iqTraPha
-   index_trac     => itZonIso
+   nqtottr = nqtot - COUNT(delPhase(tracers%gen0Name) == 'H2O' .AND. tracers%component == 'lmdz')
+   IF(COUNT(tracers%iso_iName == 0) - COUNT(delPhase(tracers%name) == 'H2O' .AND. tracers%component == 'lmdz') /= nqtottr) &
+      CALL abort_gcm(modname, 'pb dans le calcul de nqtottr', 1)
 
    !=== DISPLAY THE RESULTS
@@ -605,14 +400,14 @@
    CALL msg('Information stored in infotrac :', modname)
    IF(dispTable('isssssssssiiiiiiiii', &
-      ['iq    ', 'name  ', 'lName ', 'gen0N ', 'parent', 'type  ', 'phase ', 'compon', 'isAdv ', 'isPhy ', &
+      ['iq    ', 'name  ', 'lName ', 'gen0N ', 'parent', 'type  ', 'phase ', 'compon', 'isPhy ', 'isAdv ', &
        'iadv  ', 'iGen  ', 'iqPar ', 'nqDes ', 'nqChld', 'iGroup', 'iName ', 'iZone ', 'iPhase'],          &
-      cat(t%name, t%longName, t%gen0Name, t%parent, t%type, t%phase, t%component, bool2str(t%isAdvected),  &
-                                                                                  bool2str(t%isInPhysics)),&
-      cat([(iq, iq=1, nqtot)], t%iadv, t%iGeneration, t%iqParent, t%nqDescen, t%nqChilds, t%iso_iGroup,    &
-                                                    t%iso_iName, t%iso_iZone, t%iso_iPhase), sub=modname)) &
+      cat(t%name, t%longName, t%gen0Name, t%parent, t%type, t%phase, t%component, bool2str(t%isInPhysics), &
+                                                                                  bool2str(t%isAdvected)), &
+      cat([(iq, iq=1, nqtot)], t%iadv, t%iGeneration, t%iqParent, t%nqDescen, t%nqChildren, t%iso_iGroup,  &
+                  t%iso_iName, t%iso_iZone, t%iso_iPhase), nColMax=maxTableWidth, nHead=2, sub=modname))   &
       CALL abort_gcm(modname, "problem with the tracers table content", 1)
    IF(niso > 0) THEN
       CALL msg('Where, for isotopes family "'//TRIM(isotope%parent)//'":', modname)
-      CALL msg('  isoKeys = '//strStack(isoKeys%name), modname)
+      CALL msg('  isoKeys%name = '//strStack(isoKeys%name), modname)
       CALL msg('  isoName = '//strStack(isoName),      modname)
       CALL msg('  isoZone = '//strStack(isoZone),      modname)
@@ -623,229 +418,5 @@
    CALL msg('end', modname)
 
-END SUBROUTINE infotrac_init
-
-
-
-SUBROUTINE infotrac_setHeredity
-   !--- Purpose: Set fields %iqParent, %nqChilds, %iGeneration, %iqDescen, %nqDescen (old method)
-   USE strings_mod, ONLY: strIdx
-   INTEGER               :: iq, jq, ipere, ifils
-   INTEGER, ALLOCATABLE  :: iqfils(:,:)
-   CHARACTER(LEN=maxlen) :: msg1, modname='infotrac_init'
-   INCLUDE "iniprint.h"
-
-   !=== SET FIELDS %iqParent, %nqChilds
-   ALLOCATE(iqfils(nqtot,nqtot)); iqfils(:,:) = 0
-   tracers(:)%nqChilds = 0
-   tracers(:)%iqParent = 0
-
-   DO iq = 1, nqtot
-      msg1 = 'Tracer nr. '//TRIM(int2str(iq))//', called "'//TRIM(tracers(iq)%name)//'" is '
-
-      !--- IS IT A GENERATION 0 TRACER ? IF SO, tracers(iq)%iqParent KEEPS ITS DEFAULT VALUE (0)
-      IF(fmsg(TRIM(msg1)//' a parent', modname, tracers(iq)%parent == tran0)) CYCLE
-
-      !--- TRACERS OF GENERATION > 0 ; FIND ITS PARENT INDEX
-      ipere = strIdx(tracers(:)%name, tracers(iq)%parent)
-      IF(ipere == 0)  CALL abort_gcm('infotrac_init', TRIM(msg1)//' an orphan', 1)
-      IF(iq == ipere) CALL abort_gcm('infotrac_init', TRIM(msg1)//' its own parent',1)
-
-      CALL msg(TRIM(msg1)//' the child of '//TRIM(tracers(ipere)%name), modname)
-      tracers(iq)%iqParent    = ipere
-      tracers(ipere)%nqChilds = tracers(ipere)%nqChilds+1
-      iqfils(tracers(ipere)%nqChilds,ipere) = iq
-   END DO
-
-   CALL msg('nqGen0   = '//int2str(COUNT(tracers(:)%parent == 'air')), modname)
-   CALL msg('nqChilds = '//strStack(int2str(tracers(:)%nqChilds)),     modname)
-   CALL msg('iqParent = '//strStack(int2str(tracers(:)%iqParent)),     modname)
-   CALL msg('iqChilds = '//strStack(int2str(PACK(iqfils,MASK=.TRUE.))),modname)
-
-   !=== SET FIELDS %iGeneration, %iqDescen, %nqDescen
-   tracers(:)%iGeneration = 0
-   tracers(:)%nqDescen = 0
-   DO iq = 1, nqtot
-      ifils = iq
-      DO WHILE(tracers(ifils)%iqParent > 0)
-         ipere = tracers(ifils)%iqParent
-         tracers(ipere)%nqDescen = tracers(ipere)%nqDescen+1   
-         tracers(iq)%iGeneration = tracers(iq)%iGeneration+1
-         iqfils(tracers(ipere)%nqDescen,ipere) = iq
-         ifils = ipere
-      END DO
-      msg1 = 'Tracer nr. '//TRIM(int2str(iq))//', called "'//TRIM(tracers(iq)%name)//'" is '
-      CALL msg(TRIM(msg1)//' of generation '//TRIM(int2str(tracers(iq)%iGeneration)), modname)
-   END DO
-   DO iq=1,nqtot
-      tracers(iq)%iqDescen = iqfils(1:tracers(iq)%nqDescen,iq)
-   END DO
-
-   !=== SET FIELD %gen0Name
-   DO iq = 1, nqtot
-      jq=iq; DO WHILE(tracers(jq)%iGeneration > 0); jq=tracers(jq)%iqParent; END DO
-      tracers(iq)%gen0Name = tracers(jq)%name
-   END DO
-
-   CALL msg('nqDescen = '//TRIM(strStack(int2str(tracers(:)%nqDescen))), modname)
-   CALL msg('nqDescen_tot = ' //TRIM(int2str(SUM(tracers(:)%nqDescen))), modname)
-   CALL msg('iqDescen = '//strStack(int2str(PACK(iqfils, MASK=.TRUE.))), modname)
-
-END SUBROUTINE infotrac_setHeredity
-
-
-
-SUBROUTINE infotrac_isoinit
-
-#ifdef CPP_IOIPSL
-   USE IOIPSL
-#else
-   USE ioipsl_getincom
-#endif
-   USE readTracFiles_mod, ONLY: tnom_iso => newH2OIso
-   IMPLICIT NONE
-   INTEGER, ALLOCATABLE  :: nb_iso(:), nb_tiso(:), nb_zone(:), ix(:)
-   INTEGER               :: ii, ip, iq, it, iz, ixt
-   TYPE(isot_type), POINTER :: i
-   TYPE(trac_type), POINTER :: t(:), t1
-   CHARACTER(LEN=maxlen)    :: tnom_trac, modname, t0
-   CHARACTER(LEN=maxlen), ALLOCATABLE :: str(:)
-   LOGICAL, DIMENSION(:), ALLOCATABLE :: mask
-   REAL, ALLOCATABLE :: tnat0(:), alpha_ideal0(:)
-   INCLUDE "iniprint.h"
-
-   modname = 'infotrac_isoinit'
-   tnat0       = [ 1.0 ,  155.76e-6, 2005.2e-6, 0.004/100., 0.0 ]    !--- Same length as tnom_iso
-   alpha_ideal0= [ 1.0 ,  1.01,      1.006,     1.003,      1.0 ]    !--- Same length as tnom_iso
-   ALLOCATE(isotopes(1))                                             !--- Only water
-   nbIso = SIZE(isotopes)
-   t => tracers
-   i => isotopes(1)
-   i%parent = 'H2O'
-
-   !--- Effective isotopes names list (embedded in the "keys" field)
-   mask = t%type=='tracer' .AND. t%gen0Name==addPhase('H2O', 'g') .AND. t%iGeneration==1
-   str = PACK(delPhase(t%name), MASK=mask)
-   CALL strReduce(str)
-   i%niso = SIZE(str)
-   ALLOCATE(i%keys(i%niso))
-   i%keys(:)%name = str
-
-   !--- Check whether found isotopes are known
-   mask = [(ALL(tnom_iso /= str(ii)), ii=1, i%niso)]
-   IF(ANY(mask)) CALL abort_gcm(modname, 'The following isotopes are unknown: '//strStack(PACK(str, MASK=mask)), 1)
-
-   !--- Full isotopes list, with isotopes tagging tracers (if any) following the previous list
-   mask = t%type=='tag'    .AND. t%gen0Name==addPhase('H2O', 'g') .AND. t%iGeneration==2
-   str = PACK(delPhase(t%name), MASK=mask)
-   i%ntiso = i%niso + SIZE(str)
-   ALLOCATE(i%trac(i%ntiso))
-   i%trac(:) = [i%keys(:)%name, str]
-
-   !--- Effective tagging zones names list
-   i%zone = strTail(str, '_', .TRUE.)
-   CALL strReduce(i%zone)
-   i%nzone = SIZE(i%zone)
-   IF(i%ntiso /= i%niso*(i%nzone+1)) CALL abort_gcm(modname, 'Error in "ntiso" calculation', 1)
-
-   !--- Effective phases list
-   i%phase = ''
-   DO ip=1,nphases; IF(strIdx(t%name, addPhase('H2O', ip))/=0) i%phase=TRIM(i%phase)//known_phases(ip:ip); END DO
-   i%nphas = LEN_TRIM(i%phase)
-
-   !--- Indexes related to isotopes
-   DO iq = 1, nqtot
-      t1 => tracers(iq)
-      t0 = t1%gen0Name
-      IF(t1%iGeneration==0 .OR. .NOT.t1%isAdvected .OR. delPhase(t0)/='H2O') CYCLE
-      t1%iso_iGroup = 1
-      t1%iso_iPhase = INDEX(i%phase, getPhase(t0))
-      t1%iso_iZone = strIdx(i%zone,  strTail(t1%name, '_'))
-      IF(t1%iso_iZone /= 0) t1%iso_iName = strIdx(i%keys(:)%name, delPhase(t1%parent))
-      IF(t1%iso_iZone == 0) t1%iso_iName = strIdx(i%keys(:)%name, delPhase(t1%name  ))
-   END DO
-
-   niso_possibles = SIZE(tnom_iso)
-!   ix = strIdx(tnom_iso, i%trac)
-!   tnat        = tnat0       (PACK(ix, MASK=ix/=0))
-!   alpha_ideal = alpha_ideal0(PACK(ix, MASK=ix/=0))
-   tnat        = tnat0
-   alpha_ideal = alpha_ideal0
-
-   !--- Tests
-   nb_iso  = [(COUNT(t%iso_iPhase == ip .AND. t%iGeneration == 1), ip=1, i%nphas)]
-   nb_tiso = [(COUNT(t%iso_iPhase == ip .AND. t%iGeneration == 2), ip=1, i%nphas)]
-   nb_zone = [(COUNT(t%iso_iZone  == iz), iz=1, i%nzone)]
-   IF(ANY(nb_iso (:) /= nb_iso (1))) CALL abort_gcm(modname, 'Phases must have same number of isotopes', 1)
-   IF(ANY(nb_tiso(:) /= nb_tiso(1))) CALL abort_gcm(modname, 'Phases must have same number of tagging tracers', 1)
-   IF(i%nzone >= 1) THEN
-      IF(ANY(nb_zone(:) /= nb_zone(1))) CALL abort_gcm(modname, 'Isotopes must have the same number of tagging tracers', 1)
-   END IF
-
-   !--- Isotopic checking routines activation flag
-   i%check = .FALSE.; IF(i%niso > 0) CALL getin('ok_iso_verif', i%check)
-
-   !--- Table: index in "qx(:)" of an isotope, knowing its indices "it","ip" in "isotope%iName,%iPhase"
-   i%iqTraPha = RESHAPE([((strIdx(t%name, TRIM(addPhase(i%trac(it),ip,i%phase))),it=1,i%ntiso),ip=1,i%nphas)],[i%ntiso,i%nphas])
-
-   !--- Table: index in "isotope%tracs(:)%name" of an isotopic tagging tracer, knowing its indices "iz","ip" in "isotope%iZone,%iName"
-   i%itZonIso = RESHAPE([((strIdx(i%trac,TRIM(i%trac(it))//'_'//TRIM(i%zone(iz))),iz=1,i%nzone),it=1,i%niso )],[i%nzone,i%niso])
-
-   DO it=1,i%ntiso; CALL msg('iqTraPha('//TRIM(int2str(it))//',:) = '//strStack(int2str(i%iqTraPha(it,:))), modname); END DO
-   DO iz=1,i%nzone; CALL msg('itZonIso('//TRIM(int2str(iz))//',:) = '//strStack(int2str(i%itZonIso(iz,:))), modname); END DO
-
-   !--- Isotopic quantities (to be removed soon)
-   ok_iso_verif  = i%check
-   niso_possibles = SIZE(tnom_iso)
-   iso_num       = [(strIdx(tnom_iso(:),    strHead(delPhase(tracers(iq)%name), '_')), iq=1, nqtot)]
-   iso_indnum    = [(strIdx(i%keys(:)%name, strHead(delPhase(tracers(iq)%name), '_')), iq=1, nqtot)]
-   indnum_fn_num = [(strIdx(i%keys(:)%name, tnom_iso(ixt)), ixt=1, niso_possibles)]
-   use_iso       = indnum_fn_num /= 0            !--- .TRUE. for the effectively used isotopes of the possible isotopes list
-
-   !--- Finalize :
-   DEALLOCATE(nb_iso)
-
-END SUBROUTINE infotrac_isoinit
-
-
-!==============================================================================================================================
-!=== THE ROUTINE isoSelect IS USED TO SWITCH FROM AN ISOTOPE FAMILY TO ANOTHER: ISOTOPES DEPENDENT PARAMETERS ARE UPDATED
-!     Single generic "isoSelect" routine, using the predefined index of the parent (fast version) or its name (first call).
-!==============================================================================================================================
-LOGICAL FUNCTION isoSelectByName(iName, lVerbose) RESULT(lerr)
-   IMPLICIT NONE
-   CHARACTER(LEN=*),  INTENT(IN)  :: iName
-   LOGICAL, OPTIONAL, INTENT(IN) :: lVerbose
-   INTEGER :: iIso
-   LOGICAL :: lV
-   lV = .FALSE.; IF(PRESENT(lVerbose)) lV = lVerbose
-   iIso = strIdx(isotopes(:)%parent, iName)
-   lerr = iIso == 0
-   CALL msg('no isotope family named "'//TRIM(iName)//'"', ll=lerr .AND. lV)
-   IF(lerr) RETURN
-   lerr = isoSelectByIndex(iIso, lV)
-END FUNCTION isoSelectByName
-!==============================================================================================================================
-LOGICAL FUNCTION isoSelectByIndex(iIso, lVerbose) RESULT(lerr)
-   IMPLICIT NONE
-   INTEGER,           INTENT(IN) :: iIso
-   LOGICAL, OPTIONAL, INTENT(IN) :: lVerbose
-   LOGICAL :: lv
-   lv = .FALSE.; IF(PRESENT(lVerbose)) lv = lVerbose
-   lerr = .FALSE.
-   IF(iIso == ixIso) RETURN                                          !--- Nothing to do if the index is already OK
-   lerr = iIso<=0 .OR. iIso>nbIso
-   CALL msg('Inconsistent isotopes family index '//TRIM(int2str(iIso))//': should be > 0 and <= '//TRIM(int2str(nbIso))//'"',&
-            ll=lerr .AND. lV)
-   IF(lerr) RETURN
-   ixIso = iIso                                                      !--- Update currently selected family index
-   isotope  => isotopes(ixIso)                                       !--- Select corresponding component
-   isoKeys  => isotope%keys;     niso     => isotope%niso
-   isoName  => isotope%trac;     ntiso    => isotope%ntiso
-   isoZone  => isotope%zone;     nzone    => isotope%nzone
-   isoPhas  => isotope%phase;    nphas    => isotope%nphas
-   itZonIso => isotope%itZonIso; isoCheck => isotope%check
-   iqTraPha => isotope%iqTraPha
-END FUNCTION isoSelectByIndex
-!==============================================================================================================================
+END SUBROUTINE init_infotrac
 
 END MODULE infotrac
Index: LMDZ6/branches/Portage_acc/libf/dyn3d_common/iso_verif_dyn.F
===================================================================
--- LMDZ6/branches/Portage_acc/libf/dyn3d_common/iso_verif_dyn.F	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/dyn3d_common/iso_verif_dyn.F	(revision 4446)
@@ -64,5 +64,5 @@
         function iso_verif_aberrant_nostop
      :           (x,iso,q,err_msg)
-        USE infotrac, ONLY: tnat
+        USE infotrac, ONLY: isoName, getKey
         implicit none
         
@@ -74,5 +74,5 @@
         ! locals
         real qmin,deltaD
-        real deltaDmax,deltaDmin
+        real deltaDmax,deltaDmin,tnat
         parameter (qmin=1e-11)
         parameter (deltaDmax=200.0,deltaDmin=-999.9)
@@ -85,5 +85,10 @@
         ! verifier que HDO est raisonable
          if (q.gt.qmin) then
-             deltaD=(x/q/tnat(iso)-1)*1000
+             IF(getKey('tnat', tnat, isoName(iso))) THEN
+                  err_msg = 'Missing isotopic parameter "tnat"'
+                  iso_verif_aberrant_nostop=1
+                  RETURN
+             END IF
+             deltaD=(x/q/tnat-1)*1000
              if ((deltaD.gt.deltaDmax).or.(deltaD.lt.deltaDmin)) then
                   write(*,*) 'erreur detectee par iso_verif_aberrant:'
Index: LMDZ6/branches/Portage_acc/libf/dyn3dmem/advtrac_loc.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/dyn3dmem/advtrac_loc.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/dyn3dmem/advtrac_loc.F90	(revision 4446)
@@ -10,5 +10,5 @@
    !            M.A Filiberti (04/2002)
    !
-   USE infotrac,     ONLY: nqtot, tracers, ok_iso_verif
+   USE infotrac,     ONLY: nqtot, tracers
    USE control_mod,  ONLY: iapp_tracvl, day_step, planet_type
    USE comconst_mod, ONLY: dtvr
Index: LMDZ6/branches/Portage_acc/libf/dyn3dmem/caladvtrac_mod.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/dyn3dmem/caladvtrac_mod.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/dyn3dmem/caladvtrac_mod.F90	(revision 4446)
@@ -16,5 +16,13 @@
 
   REAL,POINTER,SAVE :: massem(:,:)
-  
+  !Offline
+  REAL,POINTER,SAVE :: tetac(:,:)
+  REAL,POINTER,SAVE :: massec(:,:)
+  REAL,POINTER,SAVE :: phic(:,:)
+  REAL,POINTER,SAVE :: pbarucc(:,:)
+  REAL,POINTER,SAVE :: pbarvcc(:,:)
+  REAL,POINTER,SAVE :: pbarugg(:,:)
+  REAL,POINTER,SAVE :: pbarvgg(:,:)
+  REAL,POINTER,SAVE :: wgg(:,:)
 CONTAINS
 
@@ -50,4 +58,13 @@
     CALL allocate_v(pbarvg,llm,d)
     CALL allocate_u(wg,llm,d)
+    ! Offline
+    CALL allocate_u(tetac,llm,d)
+    CALL allocate_u(phic,llm,d)
+    CALL allocate_u(pbarucc,llm,d)
+    CALL allocate_v(pbarvcc,llm,d)
+    CALL allocate_u(massec,llm,d)
+    CALL allocate_u(pbarugg,llm,d)
+    CALL allocate_v(pbarvgg,llm,d)
+    CALL allocate_u(wgg,llm,d)
 
     CALL groupe_allocate
Index: LMDZ6/branches/Portage_acc/libf/dyn3dmem/check_isotopes_loc.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/dyn3dmem/check_isotopes_loc.F90	(revision 4446)
+++ LMDZ6/branches/Portage_acc/libf/dyn3dmem/check_isotopes_loc.F90	(revision 4446)
@@ -0,0 +1,189 @@
+SUBROUTINE check_isotopes(q, ijb, ije, err_msg)
+   USE parallel_lmdz
+   USE strings_mod, ONLY: maxlen, msg, strIdx, strStack, int2str, real2str
+   USE infotrac,    ONLY: nqtot, niso, nphas, isotope, isoCheck, iqIsoPha, isoSelect, &
+                          ntiso, iH2O, nzone, tracers, isoName,  itZonIso, getKey
+   IMPLICIT NONE
+   include "dimensions.h"
+   REAL,             INTENT(INOUT) :: q(ijb_u:ije_u,llm,nqtot)
+   INTEGER,          INTENT(IN)    :: ijb, ije   !--- Can be local and different from ijb_u,ije_u, for example in qminimum
+   CHARACTER(LEN=*), INTENT(IN)    :: err_msg    !--- Error message to display
+   CHARACTER(LEN=maxlen) :: modname, msg1, nm(2)
+   INTEGER :: ixt, ipha, k, i, iq, iiso, izon, ieau, iqeau, iqpar
+   INTEGER, ALLOCATABLE ::   ix(:)
+   REAL,    ALLOCATABLE, SAVE :: tnat(:)         !--- OpenMP shared variable
+   REAL    :: xtractot, xiiso, deltaD, q1, q2
+   REAL, PARAMETER :: borne     = 1e19,  &
+                      errmax    = 1e-8,  &       !--- Max. absolute error
+                      errmaxrel = 1e-3,  &       !--- Max. relative error
+                      qmin      = 1e-11, &
+                      deltaDmax =1000.0, &
+                      deltaDmin =-999.0, &
+                      ridicule  = 1e-12
+   INTEGER, SAVE :: iso_eau, iso_HDO, iso_O18, & !--- OpenMP shared variables
+                             iso_O17, iso_HTO
+   LOGICAL, SAVE :: first=.TRUE.
+!$OMP THREADPRIVATE(first)
+
+   modname='check_isotopes'
+   IF(.NOT.isoCheck)    RETURN                   !--- No need to check => finished
+   IF(isoSelect('H2O')) RETURN                   !--- No H2O isotopes group found
+   IF(niso == 0)        RETURN                   !--- No isotopes => finished
+   IF(first) THEN
+!$OMP MASTER
+      iso_eau = strIdx(isoName,'H216O')
+      iso_HDO = strIdx(isoName,'HDO')
+      iso_O18 = strIdx(isoName,'H218O')
+      iso_O17 = strIdx(isoName,'H217O')
+      iso_HTO = strIdx(isoName,'HTO')
+      IF(getKey('tnat', tnat)) CALL abort_gcm(modname, 'missing isotopic parameter', 1)
+!$OMP END MASTER
+!$OMP BARRIER
+      first = .FALSE.
+   END IF
+   CALL msg('31: err_msg='//TRIM(err_msg), modname)
+
+   !--- CHECK FOR NaNs (FOR ALL THE ISOTOPES, INCLUDING GEOGRAPHIC TAGGING TRACERS)
+   modname = 'check_isotopes:iso_verif_noNaN'
+   DO ixt = 1, ntiso
+      DO ipha = 1, nphas
+         iq = iqIsoPha(ixt,ipha)
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+         DO k = 1, llm
+            DO i = ijb, ije
+               IF(ABS(q(i,k,iq))<=borne) CYCLE
+               WRITE(msg1,'(s,"(",i0,",",i0,",",i0,") = ",ES12.4)')TRIM(isoName(ixt)),i,k,iq,q(i,k,iq)
+               CALL msg(msg1, modname)
+               CALL abort_gcm(modname, 'Error with isotopes: '//TRIM(err_msg), 1)
+            END DO
+         END DO
+!$OMP END DO NOWAIT
+      END DO
+   END DO
+
+   !--- CHECK CONSERVATION (MAIN ISOTOPE AND PARENT CONCENTRATIONS MUST BE EQUAL)
+   modname = 'check_isotopes:iso_verif_egalite'
+   ixt = iso_eau
+   IF(ixt /= 0) THEN
+      DO ipha = 1, nphas
+         iq = iqIsoPha(ixt,ipha)
+         iqpar = tracers(iq)%iqParent
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+         DO k = 1, llm
+            DO i = ijb, ije
+               q1 = q(i,k,iqpar)
+               q2 = q(i,k,iq)
+!--- IMPROVEMENT in case at least one isotope is not negligible compared to the main isotopic form.
+!    This would be probably required to sum from smallest to highest concentrations ; the corresponding
+!    indices vector can be computed once only (in the initializations stage), using mean concentrations.
+!              q2 = SUM(q(i,k,tracers(iqPar)%iqDesc), DIM=3)
+               IF(ABS(q1-q2) <= errmax .OR. ABS(q1-q2)/MAX(MAX(ABS(q1),ABS(q2)),1e-18) <= errmaxrel) THEN
+                  q(i,k,iq) = q1                 !--- Bidouille pour convergence
+!                 q(i,k,tracers(iqPar)%iqDesc) = q(i,k,tracers(iqPar)%iqDesc) * q1 / q2
+                  CYCLE
+               END IF
+               CALL msg('ixt, iq = '//TRIM(strStack(int2str([ixt,iq]))), modname)
+               msg1 = '('//TRIM(strStack(int2str([i,k])))//')'
+               CALL msg(TRIM(tracers(iqpar)%name)//TRIM(msg1)//' = '//TRIM(real2str(q1)), modname)
+               CALL msg(TRIM(tracers(iq   )%name)//TRIM(msg1)//' = '//TRIM(real2str(q2)), modname)
+               CALL abort_gcm(modname, 'Error with isotopes: '//TRIM(err_msg), 1)
+            END DO
+         END DO
+!$OMP END DO NOWAIT
+      END DO
+   END IF
+
+   !--- CHECK DELTA ANOMALIES
+   modname = 'check_isotopes:iso_verif_aberrant'
+   ix = [ iso_HDO  ,   iso_O18 ]
+   nm = ['deltaD  ', 'deltaO18']
+   DO iiso = 1, SIZE(ix)
+      ixt = ix(iiso)
+      IF(ixt  == 0) CYCLE
+      DO ipha = 1, nphas
+         iq = iqIsoPha(ixt,ipha)
+         iqpar = tracers(iq)%iqParent
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+         DO k = 1, llm
+            DO i = ijb, ije
+               q1 = q(i,k,iqpar)
+               q2 = q(i,k,iq)
+!--- IMPROVEMENT in case at least one isotope is not negligible compared to the main isotopic form.
+!    This would be probably required to sum from smallest to highest concentrations ; the corresponding
+!    indices vector can be computed once only (in the initializations stage), using mean concentrations.
+!              q2 = SUM(q(i,k,tracers(iqPar)%iqDesc), DIM=3)
+               IF(q2 <= qmin) CYCLE
+               deltaD = (q2/q1/tnat(ixt)-1.)*1000.
+               IF(deltaD <= deltaDmax .AND. deltaD >= deltaDmin) CYCLE
+               CALL msg('ixt, iq = '//TRIM(strStack(int2str([ixt,iq]))), modname)
+               msg1 = '('//TRIM(strStack(int2str([i,k])))//')'
+               CALL msg(TRIM(tracers(iqpar)%name)//TRIM(msg1)//' = '//TRIM(real2str(q1)), modname)
+               CALL msg(TRIM(tracers(iq   )%name)//TRIM(msg1)//' = '//TRIM(real2str(q2)), modname)
+               CALL msg(TRIM(nm(iiso))//TRIM(real2str(deltaD)), modname)
+               CALL abort_gcm(modname, 'Error with isotopes: '//TRIM(err_msg), 1)
+            END DO
+         END DO
+!$OMP END DO NOWAIT
+      END DO
+   END DO
+
+   IF(nzone == 0) RETURN
+
+   !--- CHECK FOR TAGGING TRACERS DELTAD ANOMALIES
+   modname = 'check_isotopes:iso_verif_aberrant'
+   IF(iso_eau /= 0 .AND. iso_HDO /= 0) THEN
+      DO izon = 1, nzone
+         ixt  = itZonIso(izon, iso_HDO)
+         ieau = itZonIso(izon, iso_eau)
+         DO ipha = 1, nphas
+            iq    = iqIsoPha(ixt,  ipha)
+            iqeau = iqIsoPha(ieau, ipha)
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+            DO k = 1, llm
+               DO i = ijb, ije
+                  q1 = q(i,k,iqeau)
+                  q2 = q(i,k,iq)
+                  IF(q2<=qmin) CYCLE
+                  deltaD = (q2/q1/tnat(iso_HDO)-1.)*1000.
+                  IF(deltaD <= deltaDmax .AND. deltaD >= deltaDmin) CYCLE
+                  CALL msg('izon, ipha = '//TRIM(strStack(int2str([izon, ipha]))), modname)
+                  CALL msg( 'ixt, ieau = '//TRIM(strStack(int2str([ ixt, ieau]))), modname)
+                  msg1 = '('//TRIM(strStack(int2str([i,k])))//')'
+                  CALL msg(TRIM(tracers(iqeau)%name)//TRIM(msg1)//' = '//TRIM(real2str(q1)), modname)
+                  CALL msg(TRIM(tracers(iq   )%name)//TRIM(msg1)//' = '//TRIM(real2str(q2)), modname)
+                  CALL msg('deltaD = '//TRIM(real2str(deltaD)), modname)
+                  CALL abort_gcm(modname, 'Error with isotopes: '//TRIM(err_msg), 1)
+               END DO
+            END DO
+!$OMP END DO NOWAIT
+         END DO
+      END DO
+   END IF
+
+   !--- CHECK FOR TAGGING TRACERS CONSERVATION (PARENT AND TAGGING TRACERS SUM OVER ALL REGIONS MUST BE EQUAL)
+   DO iiso = 1, niso
+      DO ipha = 1, nphas
+         iq = iqIsoPha(iiso, ipha)
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+         DO k = 1, llm
+            DO i = ijb, ije
+               xiiso = q(i,k,iq)
+               xtractot = SUM(q(i, k, iqIsoPha(itZonIso(1:nzone,iiso), ipha)))
+               IF(ABS(xtractot-xiiso) > errmax .AND. ABS(xtractot-xiiso)/MAX(MAX(ABS(xtractot),ABS(xiiso)),1e-18) > errmaxrel) THEN
+                  CALL msg('Error in iso_verif_aberrant trac: '//TRIM(err_msg))
+                  CALL msg('iiso, ipha = '//TRIM(strStack(int2str([iiso, ipha]))), modname)
+                  CALL msg('q('//TRIM(strStack(int2str([i,k])))//',:) = '//TRIM(strStack(real2str(q(i,k,:)))), modname)
+                  CALL abort_gcm(modname, 'Error with isotopes: '//TRIM(err_msg), 1)
+               END IF
+               IF(ABS(xtractot) <= ridicule) CYCLE
+               DO izon = 1, nzone
+                  q(i,k,iq) = q(i,k,iq) / xtractot * xiiso !--- Bidouille pour convergence
+               END DO
+            END DO
+         END DO
+!$OMP END DO NOWAIT
+      END DO
+   END DO
+
+END SUBROUTINE check_isotopes
+
